<!-- Spinner -->
<ngx-spinner [name]='"workloads"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<!-- Navbar -->
<app-navbar></app-navbar>

<!-- Workload Instances Table -->
<div class="card" style="padding: 2%">
    <!-- Title -->
    <mat-label style="display: flex; justify-content: center; margin-top: 4%">
        <mat-icon style="margin-right: 9px">monitor</mat-icon>
        <h1>Workload Instances</h1>
    </mat-label>

    <!-- Search -->
    <mat-form-field appearance="outline" style="margin-left: 2%; margin-right: 2%">
        <mat-label>Search...</mat-label>
        <input matInput (keyup)="applySearch_instances($event)" placeholder="Search Instances..." #input />
    </mat-form-field>

    <!-- CRUD Table -->
    <mat-table [dataSource]="workloadInstancesTable" matSort #sort_instances="matSort" matSortActive="wi_id" matSortDirection="desc" matSortDisableClear
    class="mat-elevation-z8">
        <ng-container matColumnDef="wi_id">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> ID </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.wi_id }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="wi_instance_id">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Instance ID </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element">
                <mat-chip [removable]="false" (click)="copyToClipboard(element.wi_instance_id)">{{ element.wi_instance_id.substring(0, 7) }}...</mat-chip>
            </mat-cell>
        </ng-container>
        
        <ng-container matColumnDef="wi_release_name">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Release Name </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.wi_release_name }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="wi_workload_document_id">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Workload ID </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.wi_workload_document_id }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="wi_cluster_name">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Cluster </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element"> {{ element.wi_cluster_name }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="wi_status">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Status </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element" [ngSwitch]="element.wi_status">
                <mat-chip *ngSwitchCase="'rendered'" [removable]="false" class="status-chip" id="rendered">{{ element.wi_status }}</mat-chip>
                <mat-chip *ngSwitchCase="'deployed'" [removable]="false" class="status-chip" id="deployed">{{ element.wi_status }}</mat-chip>
                <mat-chip *ngSwitchCase="'migrating'" [removable]="false" class="status-chip" id="migrating">{{ element.wi_status }}</mat-chip>
                <mat-chip *ngSwitchCase="'evicted'" [removable]="false" class="status-chip" id="evicted">{{ element.wi_status }}</mat-chip>
                <mat-chip *ngSwitchCase="'deleted'" [removable]="false" class="status-chip" id="deleted">{{ element.wi_status }}</mat-chip>
            </mat-cell>
        </ng-container>

        <ng-container matColumnDef="wi_actions">
            <mat-header-cell class="cells" mat-header-cell *matHeaderCellDef mat-sort-header> Actions </mat-header-cell>
            <mat-cell class="cells" mat-cell *matCellDef="let element">
                <!-- Timeline -->
                <button mat-icon-button (click)="showInstanceTimeline(element)" color="primary" matTooltip="Show Instace Timeline" matTooltipPosition="above">
                    <mat-icon> timeline </mat-icon>
                </button>
                <!-- Manifests -->
                <button mat-icon-button (click)="showInstanceManifests(element.wi_id, element.wi_instance_id)" color="primary" matTooltip="Show Manifests" matTooltipPosition="above">
                    <mat-icon> description </mat-icon>
                </button>
                <!-- Delete -->
                <button mat-icon-button (click)="DeleteInstance(element.wi_id, element.wi_instance_id)" color="warn" matTooltip="Delete the Instance" matTooltipPosition="above">
                    <mat-icon> delete </mat-icon>
                </button>
            </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns_instances"></mat-header-row>
        <tr class="mat-row" *matNoDataRow>
            <td class="mat-cell" colspan="4">No Data</td>
        </tr>
        <mat-row matRipple *matRowDef="let row; columns: displayedColumns_instances"
        [class.green]="row.treatmentGroup == 'Intervention'" [class.red]="row.treatmentGroup == 'Control'"
        [class.netrual]="row.treatmentGroup == 'text something e.g null'"></mat-row>
    </mat-table>
    <mat-paginator #paginator_instances="matPaginator" [pageSizeOptions]="[10, 25, 100]" aria-label="Select page of users"></mat-paginator>
</div>